"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const webpack_config_base_1 = __importStar(require("@fbi-js/webpack-config-base"));
const path_1 = require("path");
const vue_loader_1 = require("vue-loader");
const options_1 = __importDefault(require("./options"));
exports.default = ({ webpackConfig, options: userOptions } = {}) => {
    const vueOptions = options_1.default(userOptions);
    const options = webpack_config_base_1.resolveOptions(vueOptions);
    const config = webpack_config_base_1.webpackMerge.mergeWithRules(options.mergeRules)({
        module: {
            rules: [
                {
                    test: /\.vue$/,
                    exclude: path_1.resolve('node_modules'),
                    loader: 'vue-loader',
                    options: {
                        shadowMode: true
                    }
                },
                {
                    test: /\.svg(\?v=\d+\.\d+\.\d+)?$/,
                    issuer: /\.vue$/,
                    // https://vue-svg-loader.js.org/faq.html#how-to-use-both-inline-and-external-svgs
                    oneOf: [
                        {
                            resourceQuery: /inline/,
                            use: [
                                {
                                    // https://github.com/webpack-contrib/url-loader#options
                                    loader: 'url-loader',
                                    options: {
                                        limit: 4 * 1024 // 4kb
                                    }
                                }
                            ]
                        },
                        {
                            use: ['vue-loader', 'vue-svg-loader']
                        }
                    ]
                }
            ]
        },
        plugins: [new vue_loader_1.VueLoaderPlugin()],
        resolve: {
            extensions: ['.vue'],
            alias: {
                vue: 'vue/dist/vue.esm.js'
            }
        }
    }, webpackConfig !== null && webpackConfig !== void 0 ? webpackConfig : {});
    return webpack_config_base_1.default({
        options,
        webpackConfig: config
    });
};
//# sourceMappingURL=index.js.map